diff --git a/base/server/cms/src/com/netscape/cms/servlet/tks/StandardKDF.java b/base/server/cms/src/com/netscape/cms/servlet/tks/StandardKDF.java
new file mode 100644
index 0000000..2dd145d
--- /dev/null
+++ b/base/server/cms/src/com/netscape/cms/servlet/tks/StandardKDF.java
@@ -0,0 +1,170 @@
+package com.netscape.cms.servlet.tks;
+
+import java.security.InvalidKeyException;
+
+import org.mozilla.jss.crypto.CryptoToken;
+import org.mozilla.jss.crypto.SymmetricKey;
+import org.mozilla.jss.crypto.SymmetricKeyDeriver;
+import org.mozilla.jss.crypto.TokenException;
+
+import sun.security.pkcs11.wrapper.PKCS11Constants;
+
+import com.netscape.certsrv.apps.CMS;
+import com.netscape.certsrv.base.EBaseException;
+
+public class StandardKDF extends KDF {
+    SecureChannelProtocol protocol = null;
+
+    StandardKDF(SecureChannelProtocol protocol) {
+        this.protocol = protocol;
+    }
+
+    public SymmetricKey computeCardKey(SymmetricKey masterKey, byte[] derivationData, CryptoToken token, int protocol)
+            throws EBaseException {
+
+        String method = "StandardKDF.computeCardKeys:";
+
+        SymmetricKey result = null;
+
+        CMS.debug(method + " entering ...");
+
+        if (masterKey == null || derivationData == null
+                || derivationData.length != SecureChannelProtocol.DES2_LENGTH || token == null) {
+
+            throw new EBaseException(method + " Invlalid input parameters!");
+        }
+
+        SymmetricKeyDeriver encryptDes3;
+        try {
+            encryptDes3 = token.getSymmetricKeyDeriver();
+
+            encryptDes3.initDerive(
+                    masterKey, /* PKCS11Constants.CKM_DES3_ECB_ENCRYPT_DATA */4354L, derivationData, null,
+                    PKCS11Constants.CKM_DES3_ECB, PKCS11Constants.CKA_DERIVE, 16);
+
+            SymmetricKey derivedKey = encryptDes3.derive();
+
+
+            CMS.debug(method + " derived card key first 16 :" + derivedKey);
+
+            byte[] extracted = derivedKey.getEncoded();
+            SecureChannelProtocol.debugByteArray(extracted, " Derived key 16.");
+
+            long bitPosition = 0;
+
+            byte[] param = SecureChannelProtocol.longToBytes(bitPosition);
+
+            SymmetricKeyDeriver extract8 = token.getSymmetricKeyDeriver();
+            extract8.initDerive(
+                               derivedKey, PKCS11Constants.CKM_EXTRACT_KEY_FROM_KEY,param,null,
+                               PKCS11Constants.CKA_ENCRYPT, PKCS11Constants.CKA_DERIVE,8);
+
+
+           SymmetricKey extracted8 = extract8.derive();
+           CMS.debug(method + " extracted8 key: " + extracted8);
+           byte [] extracted8Bytes = extracted8.getEncoded();
+           SecureChannelProtocol.debugByteArray(extracted8Bytes, " Derived key 8.");
+
+
+           SymmetricKeyDeriver concat = token.getSymmetricKeyDeriver();
+           concat.initDerive(
+                              derivedKey,extracted8, PKCS11Constants.CKM_CONCATENATE_BASE_AND_KEY,null,null,
+                              PKCS11Constants.CKM_DES3_ECB, PKCS11Constants.CKA_DERIVE,0);
+
+           result =  concat.derive();
+           CMS.debug(method + " final 24 byte key: " + result);
+           byte [] extracted24Bytes = result.getEncoded();
+           SecureChannelProtocol.debugByteArray(extracted24Bytes, " Derived key 24.");
+
+        } catch (TokenException | InvalidKeyException e) {
+            CMS.debug(method + "Unable to derive the key with the proper mechanism!");
+            throw new EBaseException(e);
+        }
+
+        return result;
+
+    }
+
+    public SymmetricKey computeCardKeyOnSoftToken(SymmetricKey masterKey, byte[] data, int protocol)
+            throws EBaseException {
+        String method = "StandardKDF.computeCardKeys:";
+
+        CMS.debug(method + " entering...");
+
+        if (masterKey == null || data == null) {
+            throw new EBaseException(method + " Invlalid input parameters!");
+        }
+
+        CryptoToken token = this.protocol.getCryptoManger().getInternalKeyStorageToken();
+
+        return this.computeCardKey(masterKey, data, token, protocol);
+    }
+
+    public SymmetricKey computeCardKeyOnToken(SymmetricKey masterKey, byte[] data, int protocol) throws EBaseException {
+        String method = "StandardKDF.computeCardKeys:";
+
+        if (masterKey == null || data == null) {
+            throw new EBaseException(method + " Invlalid input parameters!");
+        }
+
+        CryptoToken token = masterKey.getOwningToken();
+
+        return this.computeCardKey(masterKey, data, token, protocol);
+    }
+
+    public byte[] getDiversificationData(byte[] context, String type) throws EBaseException {
+
+        String method = "StandardKDF.getDiversificationData:";
+
+        CMS.debug(method + " entering ...");
+
+        if (context == null || type == null) {
+            throw new EBaseException(method + "Invalid input parameters!");
+        }
+
+        byte[] KDC = new byte[SecureChannelProtocol.DES2_LENGTH];
+
+        //      BYTE *lastTwoBytesOfAID     = (BYTE *)cuidValue;
+        //      BYTE *ICFabricationDate         = (BYTE *)cuidValue + 2;
+        //      BYTE *ICSerialNumber        = (BYTE *)cuidValue + 4
+        //      BYTE *ICBatchIdentifier         = (BYTE *)cuidValue + 8;
+
+        // Last 2 bytes of AID
+        KDC[0] = context[0];
+        KDC[1] = context[1];
+        KDC[2] = context[4 + 0];
+        KDC[3] = context[4 + 1];
+        KDC[4] = context[4 + 2];
+        KDC[5] = context[4 + 3];
+        KDC[6] = (byte) 0xF0;
+        KDC[7] = 0x01;
+        KDC[8] = context[0];
+        KDC[9] = context[1];
+        KDC[10] = context[4 + 0];
+        KDC[11] = context[4 + 1];
+        KDC[12] = context[4 + 2];
+        KDC[13] = context[4 + 3];
+        KDC[14] = 0x0F;
+        KDC[15] = 0x01;
+
+        if (type.equals(SecureChannelProtocol.encType))
+            return KDC;
+
+        KDC[6] = (byte) 0xF0;
+        KDC[7] = 0x02;
+        KDC[14] = 0x0F;
+        KDC[15] = 0x02;
+        if (type.equals(SecureChannelProtocol.macType))
+            return KDC;
+
+        KDC[6] = (byte) 0xF0;
+        KDC[7] = 0x03;
+        KDC[14] = 0x0F;
+        KDC[15] = 0x03;
+        if (type.equals(SecureChannelProtocol.kekType))
+            return KDC;
+
+        return KDC;
+
+    }
+}
diff --git a/base/server/cms/src/com/netscape/cms/servlet/tks/TokenServlet.java b/base/server/cms/src/com/netscape/cms/servlet/tks/TokenServlet.java
index 83b8bef..db4cd55 100644
--- a/base/server/cms/src/com/netscape/cms/servlet/tks/TokenServlet.java
+++ b/base/server/cms/src/com/netscape/cms/servlet/tks/TokenServlet.java
@@ -35,6 +35,7 @@ import org.mozilla.jss.CryptoManager.NotInitializedException;
 import org.mozilla.jss.crypto.CryptoToken;
 import org.mozilla.jss.crypto.KeyWrapAlgorithm;
 import org.mozilla.jss.crypto.KeyWrapper;
+import org.mozilla.jss.crypto.SymmetricKey;
 import org.mozilla.jss.crypto.X509Certificate;
 import org.mozilla.jss.pkcs11.PK11SymKey;
 
@@ -213,7 +214,10 @@ public class TokenServlet extends CMSServlet {
                 }
             }
 
-            SessionKey.SetDefaultPrefix(masterKeyPrefix);
+            CMS.debug("Setting masteter keky prefix to: " + masterKeyPrefix);
+
+            SecureChannelProtocol.setDefaultPrefix(masterKeyPrefix);
+            /*SessionKey.SetDefaultPrefix(masterKeyPrefix);*/
 
         } catch (Exception e) {
             e.printStackTrace();
@@ -354,7 +358,6 @@ public class TokenServlet extends CMSServlet {
 
         String rKDD = req.getParameter(IRemoteRequest.TOKEN_KDD);
 
-
         String rKeyInfo = req.getParameter(IRemoteRequest.TOKEN_KEYINFO);
 
         if ((rKeyInfo == null) || (rKeyInfo.equals(""))) {
@@ -561,7 +564,8 @@ public class TokenServlet extends CMSServlet {
                         selectedToken, keyNickName,
                         keyInfo,
                         nistSP800_108KdfOnKeyVersion, // AC: KDF SPEC CHANGE - pass in configuration file value
-                        nistSP800_108KdfUseCuidAsKdd,xCUID,xKDD, macKeyArray, sequenceCounter, derivationConstant, useSoftToken_s, keySet,
+                        nistSP800_108KdfUseCuidAsKdd, xCUID, xKDD, macKeyArray, sequenceCounter, derivationConstant,
+                        useSoftToken_s, keySet,
                         transportKeyName);
 
                 if (session_key == null) {
@@ -889,9 +893,9 @@ public class TokenServlet extends CMSServlet {
 
         boolean serversideKeygen = false;
         byte[] drm_trans_wrapped_desKey = null;
-        PK11SymKey desKey = null;
+        SymmetricKey desKey = null;
         //        PK11SymKey kek_session_key;
-        PK11SymKey kek_key;
+        SymmetricKey kek_key;
 
         IConfigStore sconfig = CMS.getConfigStore();
         boolean isCryptoValidate = true;
@@ -1092,14 +1096,15 @@ public class TokenServlet extends CMSServlet {
                                     + keySet + ".mac_key"));
                     CMS.debug("TokenServlet about to try ComputeSessionKey selectedToken="
                             + selectedToken + " keyNickName=" + keyNickName);
-                    session_key = SessionKey.ComputeSessionKey(
-                            selectedToken, keyNickName, card_challenge,
-                            host_challenge, keyInfo,
-                            nistSP800_108KdfOnKeyVersion, // AC: KDF SPEC CHANGE - pass in configuration file value
-                            nistSP800_108KdfUseCuidAsKdd, // AC: KDF SPEC CHANGE - pass in configuration file value
-                            xCUID, // AC: KDF SPEC CHANGE - removed duplicative 'CUID' variable and replaced with 'xCUID'
-                            xKDD, // AC: KDF SPEC CHANGE - pass in KDD so symkey can make decision about which value (KDD,CUID) to use
-                            macKeyArray, useSoftToken_s, keySet, transportKeyName);
+
+                    SecureChannelProtocol protocol = new SecureChannelProtocol();
+                    SymmetricKey macKey = protocol.computeSessionKey_SCP01(SecureChannelProtocol.macType,
+                            selectedToken,
+                            keyNickName, card_challenge,
+                            host_challenge, keyInfo, nistSP800_108KdfOnKeyVersion, nistSP800_108KdfUseCuidAsKdd, xCUID,
+                            xKDD, macKeyArray, useSoftToken_s, keySet, transportKeyName);
+
+                    session_key = protocol.wrapSessionKey(selectedToken, macKey, null);
 
                     if (session_key == null) {
                         CMS.debug("TokenServlet:Tried ComputeSessionKey, got NULL ");
@@ -1110,14 +1115,13 @@ public class TokenServlet extends CMSServlet {
                     byte encKeyArray[] =
                             com.netscape.cmsutil.util.Utils.SpecialDecode(sconfig.getString("tks."
                                     + keySet + ".auth_key"));
-                    enc_session_key = SessionKey.ComputeEncSessionKey(
-                            selectedToken, keyNickName, card_challenge,
-                            host_challenge, keyInfo,
-                            nistSP800_108KdfOnKeyVersion, // AC: KDF SPEC CHANGE - pass in configuration file value
-                            nistSP800_108KdfUseCuidAsKdd, // AC: KDF SPEC CHANGE - pass in configuration file value
-                            xCUID, // AC: KDF SPEC CHANGE - removed duplicative 'CUID' variable and replaced with 'xCUID'
-                            xKDD, // AC: KDF SPEC CHANGE - pass in KDD so symkey can make decision about which value (KDD,CUID) to use
-                            encKeyArray, useSoftToken_s, keySet);
+                    SymmetricKey encKey = protocol.computeSessionKey_SCP01(SecureChannelProtocol.encType,
+                            selectedToken,
+                            keyNickName, card_challenge, host_challenge, keyInfo, nistSP800_108KdfOnKeyVersion,
+                            nistSP800_108KdfUseCuidAsKdd, xCUID, xKDD, encKeyArray, useSoftToken_s, keySet,
+                            transportKeyName);
+
+                    enc_session_key = protocol.wrapSessionKey(selectedToken, encKey, null);
 
                     if (enc_session_key == null) {
                         CMS.debug("TokenServlet:Tried ComputeEncSessionKey, got NULL ");
@@ -1140,14 +1144,11 @@ public class TokenServlet extends CMSServlet {
                                 com.netscape.cmsutil.util.Utils.SpecialDecode(sconfig.getString("tks."
                                         + keySet + ".kek_key"));
 
-                        kek_key = SessionKey.ComputeKekKey(
-                                selectedToken, keyNickName, card_challenge,
-                                host_challenge, keyInfo,
-                                nistSP800_108KdfOnKeyVersion, // AC: KDF SPEC CHANGE - pass in configuration file value
-                                nistSP800_108KdfUseCuidAsKdd, // AC: KDF SPEC CHANGE - pass in configuration file value
-                                xCUID, // AC: KDF SPEC CHANGE - removed duplicative 'CUID' variable and replaced with 'xCUID'
-                                xKDD, // AC: KDF SPEC CHANGE - pass in KDD so symkey can make decision about which value (KDD,CUID) to use
-                                kekKeyArray, useSoftToken_s, keySet);
+                        kek_key = protocol.computeSessionKey_SCP01(SecureChannelProtocol.kekType, selectedToken,
+                                keyNickName, card_challenge,
+                                host_challenge, keyInfo, nistSP800_108KdfOnKeyVersion, nistSP800_108KdfUseCuidAsKdd,
+                                xCUID,
+                                xKDD, kekKeyArray, useSoftToken_s, keySet, transportKeyName);
 
                         CMS.debug("TokenServlet: called ComputeKekKey");
 
@@ -1177,11 +1178,12 @@ public class TokenServlet extends CMSServlet {
                         if (useSoftToken_s.equals("true")) {
                             CMS.debug("TokenServlet: key encryption key generated on internal");
                             //cfu audit here? sym key gen
-                            desKey = SessionKey.GenerateSymkey("internal");
+
+                            desKey = protocol.generateSymKey("internal");
                             //cfu audit here? sym key gen done
                         } else {
                             CMS.debug("TokenServlet: key encryption key generated on " + selectedToken);
-                            desKey = SessionKey.GenerateSymkey(selectedToken);
+                            desKey = protocol.generateSymKey(selectedToken);
                         }
                         if (desKey != null) {
                             // AC: KDF SPEC CHANGE - Output using CUID and KDD
@@ -1204,9 +1206,9 @@ public class TokenServlet extends CMSServlet {
                          * and discard the last 8 bytes before it encrypts.
                          * This is done so that the applet can digest it
                          */
-                        byte[] encDesKey =
-                                SessionKey.ECBencrypt(kek_key,
-                                        desKey);
+
+                        byte[] encDesKey = protocol.ecbEncrypt(kek_key, desKey, selectedToken);
+
                         /*
                         CMS.debug("computeSessionKey:encrypted desKey size = "+encDesKey.length);
                         CMS.debug(encDesKey);
@@ -1216,8 +1218,8 @@ public class TokenServlet extends CMSServlet {
                                 com.netscape.cmsutil.util.Utils.SpecialEncode(encDesKey);
 
                         // get keycheck
-                        byte[] keycheck =
-                                SessionKey.ComputeKeyCheck(desKey);
+
+                        byte[] keycheck = protocol.computeKeyCheck(desKey, selectedToken);
                         /*
                         CMS.debug("computeSessionKey:keycheck size = "+keycheck.length);
                         CMS.debug(keycheck);
@@ -1266,28 +1268,21 @@ public class TokenServlet extends CMSServlet {
                     byte authKeyArray[] =
                             com.netscape.cmsutil.util.Utils.SpecialDecode(sconfig.getString("tks."
                                     + keySet + ".auth_key"));
-                    host_cryptogram = SessionKey.ComputeCryptogram(
-                            selectedToken, keyNickName, card_challenge,
-                            host_challenge, keyInfo,
-                            nistSP800_108KdfOnKeyVersion, // AC: KDF SPEC CHANGE - pass in configuration file value
-                            nistSP800_108KdfUseCuidAsKdd, // AC: KDF SPEC CHANGE - pass in configuration file value
-                            xCUID, // AC: KDF SPEC CHANGE - removed duplicative 'CUID' variable and replaced with 'xCUID'
-                            xKDD, // AC: KDF SPEC CHANGE - pass in KDD so symkey can make decision about which value (KDD,CUID) to use
-                            0, authKeyArray, useSoftToken_s, keySet);
+
+                    host_cryptogram = protocol.computeCryptogram_SCP01(selectedToken, keyNickName, card_challenge,
+                            host_challenge,
+                            xkeyInfo, nistSP800_108KdfOnKeyVersion, nistSP800_108KdfUseCuidAsKdd, xCUID, xKDD, 0,
+                            authKeyArray, useSoftToken_s, keySet, transportKeyName);
 
                     if (host_cryptogram == null) {
                         CMS.debug("TokenServlet:Tried ComputeCryptogram, got NULL ");
                         throw new Exception("Can't compute host cryptogram!");
 
                     }
-                    card_crypto = SessionKey.ComputeCryptogram(
-                            selectedToken, keyNickName, card_challenge,
-                            host_challenge, keyInfo,
-                            nistSP800_108KdfOnKeyVersion, // AC: KDF SPEC CHANGE - pass in configuration file value
-                            nistSP800_108KdfUseCuidAsKdd, // AC: KDF SPEC CHANGE - pass in configuration file value
-                            xCUID, // AC: KDF SPEC CHANGE - removed duplicative 'CUID' variable and replaced with 'xCUID'
-                            xKDD, // AC: KDF SPEC CHANGE - pass in KDD so symkey can make decision about which value (KDD,CUID) to use
-                            1, authKeyArray, useSoftToken_s, keySet);
+
+                    card_crypto = protocol.computeCryptogram_SCP01(selectedToken, keyNickName, card_challenge,
+                            host_challenge, xkeyInfo, nistSP800_108KdfOnKeyVersion, nistSP800_108KdfUseCuidAsKdd,
+                            xCUID, xKDD, 1, authKeyArray, useSoftToken_s, keySet, transportKeyName);
 
                     if (card_crypto == null) {
                         CMS.debug("TokenServlet:Tried ComputeCryptogram, got NULL ");
@@ -1302,6 +1297,10 @@ public class TokenServlet extends CMSServlet {
                         }
                         input_card_crypto =
                                 com.netscape.cmsutil.util.Utils.SpecialDecode(rcard_cryptogram);
+
+                        SecureChannelProtocol.debugByteArray(input_card_crypto, "input_card_crypto");
+                        SecureChannelProtocol.debugByteArray(card_crypto, "card_crypto");
+
                         if (card_crypto.length == input_card_crypto.length) {
                             for (int i = 0; i < card_crypto.length; i++) {
                                 if (card_crypto[i] != input_card_crypto[i]) {
@@ -1782,18 +1781,28 @@ public class TokenServlet extends CMSServlet {
             byte kekKeyArray[] =
                     com.netscape.cmsutil.util.Utils.SpecialDecode(sconfig.getString("tks." + keySet + ".kek_key"));
 
+            SecureChannelProtocol secProtocol = new SecureChannelProtocol();
             // AC: KDF SPEC CHANGE - check for error reading settings
             if (missingSetting_exception == null) {
-                KeySetData = SessionKey.DiversifyKey(oldSelectedToken,
-                        newSelectedToken, oldKeyNickName,
-                        newKeyNickName,
-                        xkeyInfo, // AC: KDF SPEC CHANGE - pass in old key info so symkey can make decision about which KDF version to use
-                        xnewkeyInfo, // AC: BUGFIX for key versions higher than 09:  We need to specialDecode keyInfo parameters before sending them into symkey!  This means the parameters must be byte[]
-                        nistSP800_108KdfOnKeyVersion, // AC: KDF SPEC CHANGE - pass in configuration file value
-                        nistSP800_108KdfUseCuidAsKdd, // AC: KDF SPEC CHANGE - pass in configuration file value
-                        xCUID, // AC: KDF SPEC CHANGE - removed duplicative 'CUID' variable and replaced with 'xCUID'
-                        xKDD, // AC: KDF SPEC CHANGE - pass in KDD so symkey can make decision about which value (KDD,CUID) to use
-                        (protocol == 2) ? xWrappedDekKey : kekKeyArray, useSoftToken_s, keySet, (byte) protocol);
+                if (protocol == 1) {
+                    KeySetData = secProtocol.diversifyKey(oldSelectedToken,
+                            newSelectedToken, oldKeyNickName,
+                            newKeyNickName,
+                            xkeyInfo, // AC: KDF SPEC CHANGE - pass in old key info so symkey can make decision about which KDF version to use
+                            xnewkeyInfo, // AC: BUGFIX for key versions higher than 09:  We need to specialDecode keyInfo parameters before sending them into symkey!  This means the parameters must be byte[]
+                            nistSP800_108KdfOnKeyVersion, // AC: KDF SPEC CHANGE - pass in configuration file value
+                            nistSP800_108KdfUseCuidAsKdd, // AC: KDF SPEC CHANGE - pass in configuration file value
+                            xCUID, // AC: KDF SPEC CHANGE - removed duplicative 'CUID' variable and replaced with 'xCUID'
+                            xKDD, // AC: KDF SPEC CHANGE - pass in KDD so symkey can make decision about which value (KDD,CUID) to use
+                            (protocol == 2) ? xWrappedDekKey : kekKeyArray, useSoftToken_s, keySet, (byte) protocol);
+
+                } else if (protocol == 2) {
+                    KeySetData = SessionKey.DiversifyKey(oldSelectedToken, newSelectedToken, oldKeyNickName,
+                            newKeyNickName, xkeyInfo,
+                            xnewkeyInfo, nistSP800_108KdfOnKeyVersion, nistSP800_108KdfUseCuidAsKdd, xCUID, xKDD,
+                            (protocol == 2) ? xWrappedDekKey : kekKeyArray, useSoftToken_s, keySet, (byte) protocol);
+                }
+                SecureChannelProtocol.debugByteArray(KeySetData, " New keyset data: ");
 
                 if (KeySetData == null || KeySetData.length <= 1) {
                     CMS.getLogger().log(ILogger.EV_AUDIT,
@@ -1817,7 +1826,6 @@ public class TokenServlet extends CMSServlet {
 
         } // ! missingParam
 
-
         String value = "";
         String status = "0";
 
@@ -2092,7 +2100,9 @@ public class TokenServlet extends CMSServlet {
             // AC: KDF SPEC CHANGE - check for error reading settings
             if (missingSetting_exception == null) {
 
-                encryptedData = SessionKey.EncryptData(
+                SecureChannelProtocol protocol = new SecureChannelProtocol();
+
+                encryptedData = protocol.encryptData(
                         selectedToken, keyNickName, data, keyInfo,
                         nistSP800_108KdfOnKeyVersion, // AC: KDF SPEC CHANGE - pass in configuration file value
                         nistSP800_108KdfUseCuidAsKdd, // AC: KDF SPEC CHANGE - pass in configuration file value
@@ -2100,6 +2110,8 @@ public class TokenServlet extends CMSServlet {
                         xKDD, // AC: KDF SPEC CHANGE - pass in KDD so symkey can make decision about which value (KDD,CUID) to use
                         kekKeyArray, useSoftToken_s, keySet);
 
+                SecureChannelProtocol.debugByteArray(encryptedData, "New Encrypt Data: ");
+
                 // AC: KDF SPEC CHANGE - Log both CUID and KDD
 
                 CMS.getLogger().log(ILogger.EV_AUDIT,
